#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>

using namespace std;

bool valid_token (string s) {
  for (int i = 1; i <= 10; i++) {
    if (s == to_string(i)) {
      return true;
    }
  }
  return false;
}

int main (int argc, char **argv) {
  ifstream input_file (argv[1]);
  /* ifstream answer_file (argv[2]); */
  ifstream student_file (argv[3]);

  int vertexc, edgec;
  input_file >> vertexc >> edgec;

  for (int i = 1; i <= vertexc; i++) {
    int x, y;
    input_file >> x >> y;
  }

  vector<pair<int, int>> edges;
  for (int i = 0; i < edgec; i++) {
    int u, v;
    input_file >> u >> v;

    edges.push_back(make_pair(u, v));
  }
  input_file.close();

  vector<string> student_output;
  string token;
  while (student_file >> token) {
    student_output.push_back(token);
  }
  student_file.close();

  if (student_output.empty()) {
    cerr << "Presentation error: empty output!" << endl;
    cout << "0.0" << endl;
    return 0;
  }

  if ((int) student_output.size() != vertexc) {
    cerr << "Presentation error: wrong number of tokens" << endl;
    cout << "0.0" << endl;
    return 0;
  }

  for (int i = 0; i < vertexc; i++) {
    if (!valid_token(student_output[i])) {
      cerr << "Presentation error: token number " << i + 1 << " is invalid!" << endl;
      cout << "0.0" << endl;
      return 0;
    }
  }

  for (pair<int, int> e : edges) {
    int u = e.first - 1;
    int v = e.second - 1;
    if (student_output[u] == student_output[v]) {
      cerr << "Wrong answer" << endl;
      cout << "0.0" << endl;
      return 0;
    }
  }

  set<string> used_colors;
  for (int i = 0; i < vertexc; i++) {
    used_colors.insert(student_output[i]);
  }

  int K = used_colors.size();

  cerr << "OK" << endl;
  cout << fixed << setprecision(3) << 1.0 / max((double) K - 3.0, 1.0) << endl;
}
