#include <fstream>
#include <string>
#include <vector>
using namespace std;

typedef long long ll;

struct Node {
    Node* ptr[26];
    int terminal;

    Node() {
        for (int i = 0; i < 26; ++i) {
            ptr[i] = nullptr;
        }
        terminal = 0;
    }
};

pair<ll, int> Dfs(const Node* T, ll& res) {
    vector<pair<ll, int>> temp;
    for (int i = 0; i < 26; ++i) {
        if (T->ptr[i] != nullptr) {
            temp.push_back(Dfs(T->ptr[i], res));
        }
    }
    ll cum_sum = 0LL;
    int cum_cnt = 0;
    for (auto x : temp) {
        res += 1LL * T->terminal * (x.first + x.second);
        res += 1LL * (cum_sum + cum_cnt) * x.second;
        res += 1LL * (x.first + x.second) * cum_cnt;
        cum_sum += x.first;
        cum_cnt += x.second;
    }
    return make_pair(cum_sum + cum_cnt, cum_cnt + T->terminal);
}

ll Solve(const vector<string>& a) {
    int n = a.size();
    int sum_len = 0;
    auto T = new Node();

    for (auto x : a) {
        sum_len += x.size();
        auto cur_vertex = T;
        for (auto c : x) {
            if (cur_vertex->ptr[c - 'a'] == nullptr) {
                cur_vertex->ptr[c - 'a'] = new Node();
            }
            cur_vertex = cur_vertex->ptr[c - 'a'];
        }
        ++cur_vertex->terminal;
    }

    ll res = 0;
    Dfs(T, res);
    return 2LL * res;
}

int main() {
    ifstream fi("tesis.txt");
    ofstream fo("teval.txt");

    int n;
    fi >> n;
    vector<string> a(n);
    for (int i = 0; i < n; ++i) {
        fi >> a[i];
    }
    fo << Solve(a) << '\n';
    return 0;
}
